package com.iainlobb.bunnymark 
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	/**
	 * ...
	 * @author Iain Lobb - iainlobb@googlemail.com
	 */
	
	[SWF(width=640, height=480, backgroundColor=0xFFFFFF, frameRate=30)]
	 
	public class BitmapTest extends Sprite
	{
		public var numBunnies:int = 4000;
		public var gravity:Number = 3;
		public var bunnies:Vector.<BitmapBunny>;
		public var maxX:int = 640;
		public var minX:int = 0;
		public var maxY:int = 480;
		public var minY:int = 0;
		
		[Embed(source = "/wabbit_alpha.png")]
		public var BunnyAsset:Class;
		
		public function BitmapTest() 
		{
			bunnies = new Vector.<BitmapBunny>();
			
			var bunnyAsset:Bitmap = new BunnyAsset();
			
			var bunny:BitmapBunny; 
			
			for (var i:int = 0; i <= numBunnies; i++)
			{
				bunny = new BitmapBunny();
				bunny.bitmapData = bunnyAsset.bitmapData;
				bunny.speedX = Math.random() * 10;
				bunny.speedY = (Math.random() * 10) - 5;
				
				addChild(bunny);
				bunnies.push(bunny);
			}
			
			addChild(new FPS());
			
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
		
		protected function onEnterFrame(event:Event):void
		{
			var bunny:BitmapBunny; 
			
			for (var i:int = 0; i <= numBunnies; i++)
			{
				bunny = bunnies[i];
				bunny.x += bunny.speedX;
				bunny.y += bunny.speedY;
				bunny.speedY += gravity;
				
				if (bunny.x > maxX)
				{
					bunny.speedX *= -1;
					bunny.x = maxX;
				}
				else if (bunny.x < minX)
				{
					bunny.speedX *= -1;
					bunny.x = minX;
				}
				
				if (bunny.y > maxY)
				{
					bunny.speedY *= -0.8;
					bunny.y = maxY;
					
					if (Math.random() > 0.5)
					{
						bunny.speedY -= Math.random() * 12;
					}
				} 
				else if (bunny.y < minY)
				{
					bunny.speedY = 0;
					bunny.y = minY;
				}
			}
		}
		
	}
}

