package com.iainlobb.bunnymark 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	/**
	 * ...
	 * @author Iain Lobb - iainlobb@googlemail.com
	 */
	
	[SWF(width=640, height=480, backgroundColor=0xFFFFFF, frameRate=30)]
	 
	public class BlitTest extends Sprite
	{
		public var numBunnies:int = 6000;
		public var gravity:Number = 3;
		public var bunnies:Vector.<BlitBunny>;
		public var maxX:int = 640;
		public var minX:int = 0;
		public var maxY:int = 480;
		public var minY:int = 0;
		public var bitmap:Bitmap;
		
		[Embed(source = "/wabbit_alpha.png")]
		public var BunnyAsset:Class;
		
		public function BlitTest() 
		{
			bunnies = new Vector.<BlitBunny>( numBunnies, true );
			
			var bunnyAsset:Bitmap = new BunnyAsset();
			
			var bunny:BlitBunny; 
			
			for (var i:int = 0; i < numBunnies; i++)
			{
				bunny = new BlitBunny();
				bunny.position = new Point();
				bunny.bitmapData = bunnyAsset.bitmapData;
				bunny.speedX = Math.random() * 10;
				bunny.speedY = (Math.random() * 10) - 5;
				
				bunnies[i] = bunny;
			}
			
			bitmap = new Bitmap(new BitmapData(maxX, maxY));
			addChild(bitmap);
			
			addChild(new FPS());
			
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
		
		protected function onEnterFrame(event:Event):void
		{
			bitmap.bitmapData.lock();
			
			bitmap.bitmapData.fillRect(new Rectangle(0, 0, maxX, maxY), 0);
			
			var sourceRect:Rectangle = new Rectangle(0, 0, 26, 37);
			
			var bunny:BlitBunny;
			
			for (var i:int = 0; i < numBunnies; i++)
			{
				bunny = bunnies[i];
				bunny.position.x += bunny.speedX;
				bunny.position.y += bunny.speedY;
				bunny.speedY += gravity;
				
				if (bunny.position.x > maxX)
				{
					bunny.speedX *= -1;
					bunny.position.x = maxX;
				}
				else if (bunny.position.x < minX)
				{
					bunny.speedX *= -1;
					bunny.position.x = minX;
				}
				
				if (bunny.position.y > maxY)
				{
					bunny.speedY *= -0.8;
					bunny.position.y = maxY;
					
					if (Math.random() > 0.5)
					{
						bunny.speedY -= Math.random() * 12;
					}
				} 
				else if (bunny.position.y < minY)
				{
					bunny.speedY = 0;
					bunny.position.y = minY;
				}
				
				bitmap.bitmapData.copyPixels(bunny.bitmapData, sourceRect, bunny.position, null, null, true);  
			}
			
			bitmap.bitmapData.unlock();
		}
		
	}
}

